####################################################################
# YaWPS - Yet another web Portal System 
#
# Copyright (C) 2001 by Adrian Heiszler (heiszler@gmx.net) 
#
# This program is free software; you can redistribute it and/or 
# modify it under the terms of the GNU General Public License 
# as published by the Free Software Foundation; either version 2 
# of the License, or (at your option) any later version. 
#
# This program is distributed in the hope that it will be useful, 
# but WITHOUT ANY WARRANTY; without even the implied warranty of 
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the 
# GNU General Public License for more details. 
# 
# You should have received a copy of the GNU General Public License 
# along with this program; if not, write to the 
# Free Software Foundation, Inc.,
# 59 Temple Place - Suite 330, 
# Boston, MA  02111-1307, USA. 
#
#
# $Id: user.pl,v 1.6 2002/03/31 17:02:11 d3m1g0d Exp $
####################################################################


##############
sub register {
##############
	$navbar = ">>> $nav{'011'}";
	print_top();
	print qq~<form action="$cgi?action=register2" method="post">
<table border="0" cellspacing="1">
<tr>
<td><b>$msg{'006'}</b></td>
<td><input type="text" name="username" size="30" maxlength="20"></td>
</tr>
<tr>
<td><b>$msg{'007'}</b></td>
<td><input type="text" name="email" size="30" maxlength="100"></td>
</tr>
<tr>
<td colspan="2"><input type="submit" value="$btn{'004'}">
</td>
</tr>
</table>
</form>
~;
	print_bottom();
	exit;
}

###############
sub register2 {
###############
	error("$err{'003'}") if ($input{'username'} eq "");
	error("$err{'004'}") if ($input{'username'} !~ /^[0-9A-Za-z#%+,-\.:=?@^_]+$/ || $input{'username'} eq "|" || $input{'username'} =~ " " || $input{'username'} =~ /$anonuser/i);
	error("$err{'005'}") if ($input{'email'} eq "");
	error("$err{'006'}") if ($input{'email'} !~ /^[0-9A-Za-z@\._\-]+$/ || $input{'email'} =~ /(@.*@)|(\.\.)|(@\.)|(\.@)|(^\.)|(\.$)/) || ($input{'email'} !~ /\A.+@\[?(\w|[-.])+\.[a-zA-Z]{2,4}|[0-9]{1,4}\]?\Z/);
	error("$err{'007'}") if (-e ("$memberdir/$input{'username'}.dat"));

	srand(time ^ $$);
	my @passset = ('a'..'k', 'm'..'n', 'p'..'z', '2'..'9');
	my $passwrd1 = "";
	for ($i=0; $i<8; $i++) { $passwrd1 .= $passset[int(rand($#passset + 1))]; }

	$passwrd = crypt($passwrd1, substr($input{'username'}, 0, 2));

	open(FILE, ">$memberdir/$input{'username'}.dat");
	lock(FILE);
	print FILE "$passwrd\n";
	print FILE "$input{'username'}\n";
	print FILE "$input{'email'}\n";
	print FILE "\n";
	print FILE "\n";
	print FILE "$msg{'026'}\n";
	print FILE "0\n";
	print FILE "\n";
	print FILE "\n";
	print FILE "\n";
	print FILE "$date\n";
	print FILE "0\n";
	print FILE "0\n";
	print FILE "standard\n";
	close(FILE);

	open(FILE, "<$memberdir/memberlist.dat");
	@members = <FILE>;
	close(FILE);

	open(FILE, ">$memberdir/memberlist.dat");
	lock(FILE);
	foreach $curmem (@members) { print FILE "$curmem"; }
	print FILE "$input{'username'}\n";
	close(FILE);

	$subject = "$msg{'008'} $pagename";
	$message = qq~$inf{'002'}
$msg{'006'} $input{'username'}
$msg{'009'} $passwrd1
~;
	sendemail($input{'email'}, $subject, $message);

	$navbar = $nav{'011'};
	print_top();
	print qq~<table align="center" border="0" cellspacing="1">
<tr>
<td>
$inf{'003'} <b>$input{'email'}</b><br>
$inf{'004'}
</td>
</tr>
</table>
~;
	print_bottom();
	exit;
}

###########
sub login {
###########
	$navbar = ">>> $nav{'012'}";
	print_top();
	print qq~<form method="post" action="$cgi?action=login2">
<table border="0" cellspacing="1">
<tr>
<td>$msg{'006'}</td>
<td><input type="text" name="username" size="8"></td>
</tr>
<tr>
<td>$msg{'009'}</td>
<td><input type="password" name="passwrd" size="8"></td>
</tr>
<tr>
<td colspan="2"><input type="submit" value="$btn{'017'}"></td>
</tr>
<tr>
<td colspan="2"><br><a href="$cgi?action=reminder">$nav{'014'}</a></td>
</tr>
</table>
</form>
~;
	print_bottom();
	exit;
}

############
sub login2 {
############
	error("$err{'003'}") if ($input{'username'} eq "");
	error("$err{'009'}") if ($input{'passwrd'} eq "");
	error("$err{'006'}") if ($input{'username'} !~ /^[0-9A-Za-z#%+,-\.:=?@^_]+$/ || $input{'passwrd'} !~ /^[0-9A-Za-z!@#$%\^&*\(\)_\+|`~\-=\\:;'",\.\/?\[\]\{\}]+$/);
	
	if (-e("$memberdir/$input{'username'}.dat")) {
		open(FILE, "<$memberdir/$input{'username'}.dat");
		@settings = <FILE>;
		close(FILE);

		for( $i = 0; $i < @settings; $i++ ) {
			$settings[$i] =~ s~[\n\r]~~g;
		}
		$passwrd = crypt($input{'passwrd'}, substr($input{'username'}, 0, 2));
		if ($settings[0] ne $passwrd) { error("$err{'002'}"); }
	}
	else { error("$err{'010'}"); }

	print qq~Set-Cookie: $cookieusername=$input{'username'}; path=/; expires=$cookie_expdate;\n~;
	print qq~Set-Cookie: $cookiepassword=$passwrd; path=/; expires=$cookie_expdate;\n~;
	print qq~Set-Cookie: $cookieusertheme=$settings[13]; path=/; expires=$cookie_expdate;\n~;

	$username = $input{'username'};
	$password = $passwrd;
	$usertheme = $settings[13];
	loaduser();
	logvisitors();
	welcome($username);
}

############
sub logout {
############
        open(FILE, "<$datadir/log.dat");
        @entries = <FILE>;
        close(FILE);

        open(FILE, ">$datadir/log.dat");
        lock(FILE);
	$field = $username;
        foreach $curentry (@entries) {
                $curentry =~ s/\n//g;
     		($name, $value) = split(/\|/, $curentry);
                if($name ne $field) {
                        print FILE "$curentry\n";
                }
        }
        close(FILE);

	print qq~Set-Cookie: $cookieusername=; path=/; expires=Tue, 01-Jan-1980 00:00:00 GMT;\n~;
	print qq~Set-Cookie: $cookiepassword=; path=/; expires=Tue, 01-Jan-1980 00:00:00 GMT;\n~;
	print qq~Set-Cookie: $cookieusertheme=; path=/; expires=Tue, 01-Jan-1980 00:00:00 GMT;\n~;

	$username = $anonuser;
	$password = "";
	$usertheme = "standard";
	@settings = ();
	$realname = "";
	$realemail = "";
	$ENV{'HTTP_COOKIE'} = "";

	logvisitors();
	byebye();
}

##############
sub redirect {
##############
	my $username = @_;
	if ($username) { welcome($username); }
	else { print_main(); }
}

##############
sub reminder {
##############
	$navbar = ">>> $nav{'015'}";
	print_top();
	print qq~<form method="post" action="$cgi?action=reminder2">
<table border="0" cellspacing="1">
<tr>
<td>$msg{'006'} <input type="text" name="username"><input type="submit" value="$btn{'005'}"></td>
</tr>
</table>
</form>
~;
	print_bottom();
	exit;
}

###############
sub reminder2 {
###############
	if ($input{'username'} eq "") { error ("$err{'003'}"); }

	open(FILE, "<$memberdir/$input{'username'}.dat") || error("$err{'010'}");
	chomp(@settings = <FILE>);
	close(FILE);

	for ($i = 0; $i < @settings; $i++) { $settings[$i] =~ s~[\n\r]~~g; }

	srand(time ^ $$);
	my @passset = ('a'..'k', 'm'..'n', 'p'..'z', '2'..'9');
	my $passwrd1 = "";
	for ($i = 0; $i < 8; $i++) { $passwrd1 .= $passset[int(rand($#passset + 1))]; }

	$newpasswrd = crypt($passwrd1, substr($input{'username'}, 0, 2));

	open(FILE, ">$memberdir/$input{'username'}.dat");
	lock(FILE);
	print FILE "$newpasswrd\n";
	for ($i = 1; $i < @settings; $i++) { print FILE "$settings[$i]\n"; }
	close(FILE);

	$subject = "$pagename - $msg{'010'} $settings[1]";
	$message = qq~$inf{'005'} $ENV{'REMOTE_ADDR'} $inf{'006'} $input{'username'} $inf{'007'}

$msg{'006'} $input{'username'}
$msg{'009'} $passwrd1

$msg{'011'} $settings[7]

$inf{'008'}
~;
	sendemail($settings[2], $subject, $message);

	$navbar = ">>> $nav{'015'}";
	print_top();
	print qq~$inf{'003'} <b>$settings[2]</b>~;
	print_bottom();
	exit;
}

#############
sub welcome {
#############
	open(FILE, "<$memberdir/$username.dat") || error("$err{'010'}");
	chomp(@memsettings = <FILE>);
	close(FILE);

	if ($memsettings[9] eq "") { $memsettings[9] = "_nopic.gif"; }
	if ($memsettings[9] =~ /^\http:\/\// ) {
		if ($memberpic_width != 0) { $tmp_width = qq~width="$memberpic_width"~; } 
		else { $tmp_width = ""; }
		if ($memberpic_height != 0) { $tmp_height = qq~height="$memberpic_height"~; } 
		else { $tmp_height = ""; }
		$memberpic = qq~<img src="$memsettings[9]" $tmp_width $tmp_height border="0" alt=""></a>~;
	}
	else {
		$memberpic = qq~<img src="$imagesurl/avatars/$memsettings[9]" border="0" alt=""></a>~;
	}

	$navbar = "";
	print_top();
	print qq~<p class="texttitle">$memsettings[1], $msg{'163'}</p>
<b><u>$msg{'164'}</u></b><br>
<table>
<td valign="top">
<table>
<tr>
<td><b>$msg{'007'}</b></td>
<td><a href="mailto:$memsettings[2]">$memsettings[2]</a></td>
</tr>
<tr>
<td><b>$msg{'014'}</b></td>
<td><a href="$memsettings[4]" target="_blank">$memsettings[3]</a></td>
</tr>
<tr>
<td><b>$msg{'016'}</b></td>
<td>$memsettings[8]</td>
</tr>
<tr>
<td><b>$msg{'021'}</b></td>
<td>$memsettings[6]</td>
</tr>
<tr>
<td><b>$msg{'022'}</b></td>
<td>$memsettings[11]</td>
</tr>
<tr>
<td><b>$msg{'023'}</b></td>
<td>$memsettings[12]</td>
</tr>
</table>
</td>
<td>$memberpic</td>
</tr>
</table>
<br>
<b><u>$msg{'165'}</u></b><br>
<table>
<tr>
<td><a href="$cgi?action=editprofile&amp;username=$username">$nav{'016'}</a><br>
<a href="$cgi?action=editpb">$nav{'050'}</a><br>
<a href="$cgi?action=">$nav{'051'}</a><br>
<a href="$cgi?action=logout">$nav{'034'}</a><br></td>
</tr>
</table>
~;
	print_bottom;
	exit;
}

############
sub byebye {
############
	$navbar = "";
	print_top();
	print qq~$inf{'017'}<br>
<a href="$pageurl/$cgi">$nav{'052'}</a>~;
	print_bottom;
	exit;
}

#################
sub editprofile {
#################
	if ($info{'username'} =~ /\//){ error("$err{'004'}" ); }
	if ($info{'username'} =~ /\\/){ error("$err{'004'}" ); }
	if (($info{'username'} eq "admin") && ($username ne "admin")) { error("$err{'011'}" ); }

	open(FILE, "<$memberdir/$info{'username'}.dat") || error("$err{'010'}");
	chomp(@memsettings = <FILE>);
	close(FILE);

	$signature = $memsettings[5];
	$signature =~ s/\&\&/\n/g;

	if ($settings[0] ne $memsettings[0] && $settings[7] ne $userlevel[0]) { error("$err{'011'}"); }

	$navbar = ">>> $nav{'016'}";
	print_top();
	print qq~<table border="0" cellspacing="1">
<tr>
<td><form action="$cgi?action=editprofile2" method="post" name="creator">
<table border="0">
<tr>
<td><b>$msg{'006'}</b></td>
<td><input type="hidden" name="username" value="$info{'username'}">$info{'username'}</td>
</tr>
<tr>
<td><b>$msg{'009'}</b></td>
<td><input type="password" name="passwrd1" size="20" value="$memsettings[0]">*</td>
</tr>
<tr>
<td><b>$msg{'009'}</b></td>
<td><input type="password" name="passwrd2" size="20" value="$memsettings[0]">*</td>
</tr>
<tr>
<td><b>$msg{'013'}</b></td>
<td><input type="text" name="name" size="40" value="$memsettings[1]">*</td>
</tr>
<tr>
<td><b>$msg{'007'}</b></td>
<td><input type="text" name="email" size="40" value="$memsettings[2]">*</td>
</tr>
<tr>
<td><b>$msg{'014'}</b></td>
<td><input type="text" name="websitetitle" size="40" value="$memsettings[3]"></td>
</tr>
<tr>
<td><b>$msg{'015'}</b></td>
<td><input type="text" name="websiteurl" size="40" value="$memsettings[4]"></td>
</tr>
<tr>
<td><b>$msg{'016'}</b></td>
<td><input type="text" name="icq" size="40" value="$memsettings[8]"></td>
</tr>
<tr>
<td valign="top"><b>$msg{'017'}</b></td>
<td><textarea name="signature" rows="4" cols="35" wrap="virtual">$signature</textarea></td>
</tr>
<tr>
<td valign="top"><b>$msg{'161'}</b></td>
<td><select name="theme">
~;
	open(FILE, "<$themesdir/themes.dat");
	@themes = <FILE>;
	close(FILE);

	foreach $line (@themes) {
		$line =~ s/[\n\r]//g;
		@item = split(/\|/, $line);
		if ($memsettings[13] eq $item[1]) { print qq~<option value="$item[1]" selected>$item[0]</option>\n~; }
		else { print qq~<option value="$item[1]">$item[0]</option>\n~; }
	}
	print qq~</select>
</td>
</tr>
~;
	opendir(DIR, "$imagesdir/avatars");
	@contents = readdir(DIR);
	closedir(DIR);

	$images = "";
	if ($memsettings[9] eq "") { $memsettings[9] = "_nopic.gif"; }
	foreach $line (sort @contents) {
		($name, $extension) = split (/\./, $line);
		$checked = "";
		if ($line eq $memsettings[9]) { $checked = " selected"; }
		if ($memsettings[9] =~ m~\Ahttp://~ && $line eq "") { $checked = " selected"; }
		if ($extension =~ /gif/i || $extension =~ /jpg/i || $extension =~ /jpeg/i || $extension =~ /png/i ) {
			if ($line eq "_nopic.gif") { 
				$name = ""; 
				$pic = "_nopic.gif";
			}
			$images .= qq~<option value="$line"$checked>$name</option>\n~;
		}
	}
	if ($memsettings[9] =~ m~\Ahttp://~) {
		$pic = $memsettings[9];
		$checked = " checked";
		$tmp = $memsettings[9];
	}
	else {
		$pic = "$imagesurl/avatars/$memsettings[9]";
		$tmp = "http://";
	}
	print qq~<tr>
<td valign="top"><b>$msg{'018'}</b></td>
<td valign="top">
<table>
<tr>
<td>$msg{'012'}</td>
</tr>
<tr>
<td><script language="javascript" type="text/javascript">
<!--
function showImage() {
document.images.avatars.src="$imagesurl/avatars/"+document.creator.memberpic.options[document.creator.memberpic.selectedIndex].value;
}
// -->
</script>
<select name="memberpic" onChange="showImage()" size="6">
$images</select>
<img src="$pic" name="avatars" border="0" hspace="15"></td>
</tr>
<tr>
<td>$msg{'020'}</td>
</tr>
<tr>
<td><input type="checkbox" name="memberpicpersonalcheck"$checked>
<input type="text" name="memberpicpersonal" size="40" value="$tmp"><br>
$msg{'019'}</td>
</tr>
</table>
</td>
</tr>
~;

	if ($settings[7] eq $userlevel[0]) {
		$pos = "";
		if ($memsettings[7] eq "") { 
			foreach $row (@userlevel[0..1]) {
				$row =~ s/[\n\r]//g;
				if ($memsettings[7] eq $row) { $pos = qq~$pos<option value="$row" selected>$row</option>\n~; }
				else { $pos = qq~$pos<option value="$row">$row</option>\n~; }
			}
			$pos = qq~$pos<option value="" selected>$userlevel[2]</option>\n~; 
		}
		else {
			foreach $row (@userlevel[0..1]) {
				$row =~ s/[\n\r]//g;
				if ($memsettings[7] eq $row) { $pos = qq~$pos<option value="$row" selected>$row</option>\n~; }
				else { $pos = qq~$pos<option value="$row">$row</option>\n~; }
			}
			$pos = qq~$pos<option value="">$userlevel[2]</option>\n~; 
		}		

		print qq~<tr>
<td><b>$msg{'021'}</b></td>
<td><input type="text" name="settings6" size="4" value="$memsettings[6]"></td>
</tr>
<tr>
<td><b>$msg{'022'}</b></td>
<td><input type="text" name="settings11" size="4" value="$memsettings[11]"></td>
</tr>
<tr>
<td><b>$msg{'023'}</b></td>
<td><input type="text" name="settings12" size="4" value="$memsettings[12]"></td>
</tr>
<tr>
<td><b>$msg{'024'}</b></td>
<td><select name="settings7">
$pos</select></td>
</tr>
<tr>
<td colspan="2">* $msg{'025'}</td>
</tr>
<tr>
<td colspan="2"><input type="hidden" name="settings8" value="$memsettings[8]">
<input type="hidden" name="settings10" value="$memsettings[10]">
~;
	}
	else {
		print qq~<tr>
<td colspan="2">* $msg{'025'}</td>
</tr>
<tr>
<td colspan="2"><input type="hidden" name="settings6" value="$memsettings[6]">
<input type="hidden" name="settings7" value="$memsettings[7]">
<input type="hidden" name="settings8" value="$memsettings[8]">
<input type="hidden" name="settings10" value="$memsettings[10]">
<input type="hidden" name="settings11" value="$memsettings[11]">
<input type="hidden" name="settings12" value="$memsettings[12]">
~;
	}
	print qq~<input type="submit" name="moda" value="$btn{'006'}">
<input type="submit" name="moda" value="$btn{'007'}"></td>
</tr>
</table>
</form>
</td>
</tr>
</table>
~;
	print_bottom();
	exit;
}

##################
sub editprofile2 {
##################
	if ($info{'username'} =~ /\//) { error("$err{'004'}" ); }
	if ($info{'username'} =~ /\\/) { error("$err{'004'}" ); }
	if (($username ne "admin") && ($input{'username'} eq "admin")) { error("$err{'011'}" ); }
	if ($input{'passwrd1'} ne $input{'passwrd2'}) { error("$err{'012'}"); }
	if ($input{'passwrd1'} eq "") { error("$err{'009'}"); }
	if ($input{'name'} eq "") { error("$err{'013'}"); }
	if ($input{'name'} !~ /^[0-9A-Za-z#%+,-\.:=?@^_]+$/ || $input{'name'} eq "|" || $input{'name'} =~ " " || $input{'name'} =~ /$anonuser/i) { error("$err{'006'}"); }
	if ($input{'email'} eq "") { error("$err{'005'}"); }

	if ($input{'memberpicpersonalcheck'} && ( $input{'memberpicpersonal'} =~ m/\.gif\Z/i || $input{'memberpicpersonal'} =~ m/\.jpg\Z/i || $input{'memberpicpersonal'} =~ m/\.jpeg\Z/i || $input{'memberpicpersonal'} =~ m/\.png\Z/i ) ) {
		$input{'memberpic'} = $input{'memberpicpersonal'};
	}
	if ($input{'memberpic'} !~ m^\A[0-9a-zA-Z_\.\#\%\-\:\+\?\$\&\~\.\,\@/]+\Z^) { error("$err{'006'}"); }

	open(FILE, "<$memberdir/$input{'username'}.dat") || error("$err{'010'}");
	chomp(@memsettings = <FILE>);
	close(FILE);

	if ($input{'passwrd1'} eq $memsettings[0]) { $passwrd = $input{'passwrd1'}; }
	else { $passwrd = crypt($input{'passwrd1'}, substr($input{'username'}, 0, 2)); }

	if ($input{'moda'} eq $btn{'006'}) {
		if ($input{'signature'} eq "") { $input{'signature'} = "$msg{'026'}"; }
		$input{'signature'} =~ s/\n/\&\&/g;
		$input{'signature'} =~ s/\r//g;

		open(FILE, ">$memberdir/$input{'username'}.dat") || error("$err{'016'} $input{'username'}.dat");
		lock(FILE);
		print FILE "$passwrd\n";
		print FILE "$input{'name'}\n";
		print FILE "$input{'email'}\n";
		print FILE "$input{'websitetitle'}\n";
		print FILE "$input{'websiteurl'}\n";
		print FILE "$input{'signature'}\n";
		print FILE "$input{'settings6'}\n";
		print FILE "$input{'settings7'}\n";
		print FILE "$input{'icq'}\n";
		print FILE "$input{'memberpic'}\n";
		print FILE "$input{'settings10'}\n";
		print FILE "$input{'settings11'}\n";
		print FILE "$input{'settings12'}\n";
		print FILE "$input{'theme'}\n";
		close(FILE);

		open(FILE, "<$memberdir/$input{'username'}.dat");
		@settings = <FILE>;
		close(FILE);

		for( $i = 0; $i < @settings; $i++ ) {
			$settings[$i] =~ s~[\n\r]~~g;
		}

		if ($input{'username'} eq $username) {
			$username = $input{'username'};
			$usertheme = $settings[13];
			$password = $passwrd;
			print qq~Set-Cookie: $cookieusername=$username; path=/; expires=$cookie_expdate;\n~;
			print qq~Set-Cookie: $cookiepassword=$password; path=/; expires=$cookie_expdate;\n~;
			print qq~Set-Cookie: $cookieusertheme=$usertheme; path=/; expires=$cookie_expdate;\n~;

			loaduser();
			logvisitors();
			welcome($username);
		}
		else {
			print "Location: $cgi\?action=memberlist\n\n";
		}
	} 
	else {
		unlink("$memberdir/$input{'username'}.dat");
		unlink("$memberdir/$input{'username'}.msg");
		unlink("$memberdir/$input{'username'}.log");

		open(FILE, "<$memberdir/memberlist.dat");
		chomp(@members = <FILE>);
		close(FILE);

		open(FILE, ">$memberdir/memberlist.dat");
		lock(FILE);
		foreach $curmem (@members) {
			if ($curmem ne $input{'username'}) { print FILE "$curmem\n"; }
		}
		close(FILE);

		if ($input{'username'} eq $username) { 
			print qq~Set-Cookie: $cookieusername=; path=/; expires=Tue, 01-Jan-1980 00:00:00 GMT;\n~;
			print qq~Set-Cookie: $cookiepassword=; path=/; expires=Tue, 01-Jan-1980 00:00:00 GMT;\n~;
			print qq~Set-Cookie: $cookieusertheme=; path=/; expires=Tue, 01-Jan-1980 00:00:00 GMT;\n~;

			$username = $anonuser;
			$password = "";
			$usertheme = "standard";
			@settings = ();
			$realname = "";
			$realemail = "";
			$ENV{'HTTP_COOKIE'} = "";

			logvisitors();
			byebye(); 
		}
		else { 
			print "Location: $cgi\?action=memberlist\n\n";
		}
	}
	exit;
}

##################
sub viewprofile {
##################
	if ($info{'username'} =~ /\//) { error("$err{'004'}"); }
	if ($info{'username'} =~ /\\/) { error("$err{'004'}"); }
	if ($username eq $anonuser) { error("$err{'011'}"); }

	open(FILE, "<$memberdir/$info{'username'}.dat") || error("$err{'010'}");
	chomp(@memsettings = <FILE>);
	close(FILE);

	if ($memsettings[9] eq "") { $memsettings[9] = "_nopic.gif"; }
	if ($memsettings[9] =~ /^\http:\/\// ) {
		if ($memberpic_width != 0) { $tmp_width = qq~width="$memberpic_width"~; } 
		else { $tmp_width = ""; }
		if ($memberpic_height != 0) { $tmp_height = qq~height="$memberpic_height"~; } 
		else { $tmp_height = ""; }
		$memberpic = qq~<img src="$memsettings[9]" $tmp_width $tmp_height border="0" alt=""></a>~;
	}
	else {
		$memberpic = qq~<img src="$imagesurl/avatars/$memsettings[9]" border="0" alt=""></a>~;
	}

	open(FILE, "<$memberdir/membergroups.dat");
	@memberranks = <FILE>;
	close(FILE);

	$memberinfo = $memberranks[0];

	$ranking = $memsettings[6]+$memsettings[11]+$memsettings[12];
	if ($ranking > 25) { $memberinfo = $memberranks[1]; }
	if ($ranking > 50) { $memberinfo = $memberranks[2]; }
	if ($ranking > 75) { $memberinfo = $memberranks[3]; }
	if ($ranking > 100) { $memberinfo = $memberranks[4]; }
	if ($ranking > 250) { $memberinfo = $memberranks[5]; }
	if ($ranking > 500) { $memberinfo = $memberranks[6]; }
	if ($memsettings[7] ne "") { $memberinfo = $memsettings[7]; }
	if ($memsettings[7] eq $userlevel[0]) { $memberinfo = $userlevel[0]; }

	$navbar = ">>> $nav{'017'}";
	print_top();
	print qq~<table border="0" width="100%" cellspacing="1">
<tr>
<td><b>$info{'username'}</b> 
~;
	if (($info{'username'} eq $username) || ($setting[7] = $userlevel[0])) { print qq~[<a href="$cgi?action=editprofile&amp;username=$info{'username'}">$nav{'016'}</a>]~; }
	if ($info{'username'} ne $username) { print qq~ [<a href="$cgi?action=imsend&amp;to=$info{'username'}">$nav{'018'}</a>]~; }

	print qq~</td>
</tr>
<tr>
<td>
<table border="0">
<tr>
<td><b>$msg{'013'}</b></td>
<td>$memsettings[1]</td>
</tr>
<tr>
<td><b>$msg{'007'}</b></td>
<td><a href="mailto:$memsettings[2]">$memsettings[2]</a></td>
</tr>
<tr>
<td><b>$msg{'014'}</b></td>
<td><a href="$memsettings[4]" target="_blank">$memsettings[3]</a></td>
</tr>
<tr>
<td><b>$msg{'016'}</b></td>
<td>$memsettings[8]</td>
</tr>
<tr>
<td><b>$msg{'021'}</b></td>
<td>$memsettings[6]</td>
</tr>
<tr>
<td><b>$msg{'022'}</b></td>
<td>$memsettings[11]</td>
</tr>
<tr>
<td><b>$msg{'023'}</b></td>
<td>$memsettings[12]</td>
</tr>
<tr>
<td><b>$msg{'024'}</b></td>
<td>$memberinfo</td>
</tr>
<tr>
<td><b>$msg{'027'}</b></td>
<td>$dr</td>
</tr>
<tr>
<td valign="top"><b>$msg{'018'}</b></td>
<td>$memberpic</td>
</tr>
</table>
</td>
</tr>
</table>
~;
	print_bottom();
	exit;
}

1; # return true
