####################################################################
# YaWPS - Yet another web Portal System 
#
# Copyright (C) 2001 by Adrian Heiszler (heiszler@gmx.net) 
#
# This program is free software; you can redistribute it and/or 
# modify it under the terms of the GNU General Public License 
# as published by the Free Software Foundation; either version 2 
# of the License, or (at your option) any later version. 
#
# This program is distributed in the hope that it will be useful, 
# but WITHOUT ANY WARRANTY; without even the implied warranty of 
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the 
# GNU General Public License for more details. 
# 
# You should have received a copy of the GNU General Public License 
# along with this program; if not, write to the 
# Free Software Foundation, Inc.,
# 59 Temple Place - Suite 330, 
# Boston, MA  02111-1307, USA. 
#
#
# $Id: config.pl,v 1.5 2002/03/31 17:12:05 d3m1g0d Exp $
####################################################################


##################
# General Settings
##################
$pagename = "YaWPS";
$pageurl = "http://$ENV{'SERVER_NAME'}/YaWPS";
$pagetitle = "YaWPS - Yet another Web Portal System";

$cgi = "yawps.cgi";
$cookieusername = "yawpsuid";
$cookiepassword = "yawpspwd";
$cookieusertheme = "yawpsthm";

$mailtype = 0;
$mailprogram = "/usr/sbin/sendmail -t";
$smtp_server = "";   

$scriptdir = "$ENV{'DOCUMENT_ROOT'}/YaWPS";
$sourcedir = "$scriptdir/cgi-lib";
$datadir = "$scriptdir/db";
$memberdir = "$datadir/members";
$imagesdir = "$scriptdir/images";
$themesdir = "$scriptdir/themes";

$imagesurl = "/YaWPS/images";
$themesurl = "/YaWPS/themes";

$lang = "$scriptdir/lang/english.lng";

########################
# News Specific Settings
########################
$topicsdir = "$datadir/topics";
$maxnews = 5;
$maxtopics = 25;
$enable_userarticles = 1;

##########################
# Forums Specific Settings
##########################
$boardsdir = "$datadir/forum";
$messagedir = "$datadir/forum/messages";

$enable_guestposting = 1;
$enable_notification = 1;
$maxdisplay = 25;
$maxmessagedisplay = 15;
$insert_original = 0;
$max_log_days_old = 21;

#########################
# Stats Specific Settings
#########################
$logdir = "$datadir/stats";
$ip_time = 5;

#########################
# Links Specific Settings
#########################
$linksdir = "$datadir/links";
$maxlinks = 25;

################
# Other Settings
################
$timeoffset = 6;

$memberpic_height = 93;
$memberpic_width = 60;

$use_flock = 1;
$LOCK_EX = 2;
$LOCK_UN = 8;

$IIS = 0;

1; #return true
